/***************************************************************************
 *   Copyright (C) 2006 by Michael Andreen                                 *
 *   andreen@student.chalmers.se                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

#include "model.h"
#include "models.h"

#include <stdexcept>

Model::Model(Models::ModelImpl* model): _impl(model){
}

double Model::score(const SortAction& sa, const GeneOrder& go) const{
	return _impl->score(sa, go);
}

const char* Model::name() const{
	return _impl->name();
}

bool operator<(const Model& lh,const Model& rh){
	return &lh < &rh;
}

Model Model::modelFactory(const std::string& name){
	if (name == "X"){
		return Model(new Models::X());
	}else if(name == "Whirl" || name == "Standard"){
		return Model(new Models::ModelImpl());
	}else if(name == "Zipper"){
		return Model(new Models::Zipper());
	}else if(name == "FatX"){
		return Model(new Models::FatX());
	}else if(name == "Cloud"){
		return Model(new Models::Cloud());
	}
	throw std::invalid_argument(name + " is not a valid model");
}
